#include<stdio.h>

int n,q,a[200001];
int p,k,r;

int main(){

    scanf("%d%d",&n,&q);

    for(int i=1;i<=n;i++)scanf("%d",&a[i]);

    for(int i=0;i<q;i++){
        scanf("%d%d",&p,&k);
        r=a[p];
        for(int j=p+1;j<=k;j++)r=r&a[j];
        printf("%d",r);
    }

    return 0;
}